import os
import sys

from ahisto_named_entity_search.recognition import NerModel


if __name__ == '__main__':
    assert len(sys.argv) == 4

    search_method = sys.argv[1]
    cross_page_boundaries = sys.argv[2]
    only_relevant = sys.argv[3]

    project_name = f'AHISTO NER: {search_method}, {cross_page_boundaries}, {only_relevant}'
    os.environ['COMET_PROJECT_NAME'] = project_name

    model_basename = f'model_ner_{search_method}_{cross_page_boundaries}_{only_relevant}'
    model_checkpoint_basename = f'{model_basename}_checkpoints'

    sentence_basename = f'dataset_mlm_{cross_page_boundaries}_{only_relevant}'
    training_sentence_basename = f'{sentence_basename}_training'
    validation_sentence_basename = f'{sentence_basename}_validation'

    tagged_sentence_basename = f'dataset_ner_{search_method}_{cross_page_boundaries}_{only_relevant}'
    training_tagged_sentence_basename = f'{tagged_sentence_basename}_training'
    validation_tagged_sentence_basename = f'{tagged_sentence_basename}_validation'

    try:
        NerModel.load(model_basename)
    except EnvironmentError:
        NerModel.train_and_save(model_checkpoint_basename, model_basename,
                                training_sentence_basename, validation_sentence_basename,
                                training_tagged_sentence_basename,
                                validation_tagged_sentence_basename)
